//分为标准模式和调校模式，调校模式可通过两个电位计分别控制灯带和水泵频率

#include <PWM.h>                  // PWM Frequency library available at https://code.google.com/archive/p/arduino-pwm-frequency-library/downloads

const byte SValve = 5;            // 水泵 D5
const byte LED_strip = 3;        // 灯带 D3

const byte Mode = A0;  // Switch开关调模式 A0  HIGH为标准模式 LOW为调校模式
const byte frequency_sValve_GET = A2; //电位计调水泵频率 A2
const byte frequency_led_GET = A6; //电位计调灯带频率 A6

float BASE_FREQ =  48 ; //基准频率
float frequency_offset = 0.2;  //频率差
float duty_sValve = 2;   //水泵占空比 
float frequency_sValve = BASE_FREQ;  // 水泵频率设置为基准频率
float duty_led = 7;   // 灯带占空比 调亮度
float frequency_led = frequency_sValve+frequency_offset;    //灯带频率设置为基准频率加频率差


//**********************************************************************************************************************************************************
void setup()
{
  Serial.begin(9600);

  //initialize all timers except for 0, to save time keeping functions
  InitTimersSafe();

  //sets the frequency for the specified pin
  bool success = SetPinFrequencySafe(LED_strip, frequency_led);
  
  bool success2 = SetPinFrequencySafe(SValve, frequency_sValve);
  
  if(success and success2) 
    Serial.print("init pwm successfully");    
}



//**********************************************************************************************************************************************************
void loop()
{      


if (!digitalRead(Mode)) {
  
Serial.print("调试模式已启动");
Serial.print("\n");

float duty_led = 7;//7    灯带占空比 调亮度
Serial.print("灯带占空比 = ");
Serial.print(duty_led);
Serial.print("\n");

float frequency_sValve = map(analogRead(frequency_sValve_GET),0,1023,20,60);  // 水泵频率设置为基准频率
Serial.print("水泵频率 = ");
Serial.print(frequency_sValve);
Serial.print("\n");

float frequency_led = map(analogRead(frequency_led_GET),0,1023,20,60);    //灯带频率设置为基准频率加频率差
Serial.print("灯带频率 = ");
Serial.print(frequency_led);
Serial.print("\n");

Serial.print("灯带水泵频率差 = ");
Serial.print(frequency_led-frequency_sValve);
Serial.print("\n");
Serial.print("\n");

// Open the waterPump with speices frequency and duty
SetPinFrequencySafe(SValve, frequency_sValve);
sValve_on();

// Open the LED_strip with speices frequency and duty
SetPinFrequencySafe(LED_strip, frequency_led);  
pwmWrite(LED_strip, round(duty_led*255/100));   

}

else
{
Serial.print("标准模式已启动");
Serial.print("\n");
  
//float BASE_FREQ = 45;
Serial.print("基准频率 = ");
Serial.print(BASE_FREQ);
Serial.print("\n");

//float frequency_offset = 0.4;
Serial.print("频率差 = ");
Serial.print(frequency_offset);
Serial.print("\n");

float duty_led = 7;//7    灯带占空比 调亮度
Serial.print("灯带占空比 = ");
Serial.print(duty_led);
Serial.print("\n");

float frequency_sValve = BASE_FREQ;  // 水泵频率设置为基准频率
Serial.print("水泵频率 = ");
Serial.print(frequency_sValve);
Serial.print("\n");


float frequency_led = frequency_sValve+frequency_offset;    //灯带频率设置为基准频率加频率差
Serial.print("灯带频率 = ");
Serial.print(frequency_led);
Serial.print("\n");
Serial.print("\n");





// Open the waterPump with speices frequency and duty
SetPinFrequencySafe(SValve, frequency_sValve);
sValve_on();

// Open the LED_strip with speices frequency and duty
SetPinFrequencySafe(LED_strip, frequency_led);  
pwmWrite(LED_strip, round(duty_led*255/100));   
 
}
  
  
  }  




//**********************************************************************************************************************************************************
void sValve_on() 
{
 pwmWrite(SValve, 255); 
}



//**********************************************************************************************************************************************************
void sValve_off() 
{
  pwmWrite(SValve, 0);  
}
